/*! hash:70f48b2adf591b3be069, chunkhash:89c528236b8d16733360, name:main, filebase:bundle.js, query:, file:bundle.js */
/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 7);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports) {

module.exports = require("fs");

/***/ }),
/* 1 */
/***/ (function(module, exports, __webpack_require__) {

const fs = __webpack_require__(0);
const fss = __webpack_require__(11);
const mkdirp = __webpack_require__(3);
const path = __webpack_require__(4);
var file_conf_name = null;
var finfos = null;
const fileInfo = null;
var cfg_path = null;
const lockFile = [];
var document = null;
const lockType = {
	remote: 0,
	fileInfos: 1,
}
const lockFd = [null, null];

function load(_path, _fname, _doc) {
	if (_path) cfg_path = _path;
	if (_fname) file_conf_name = cfg_path + '/' + _fname;
	if (_doc) document = _doc;
	mkdirp.sync(cfg_path);
	if (!fs.existsSync(file_conf_name)) {
		finfos = {
			files: {},
			path: null,
		};
	} else {
		var fjson = "";
		var bufjson = fs.readFileSync(file_conf_name, 'utf8');
		finfos = JSON.parse(bufjson.toString());
	}

	if (!lockFile[lockType.remote]) lockFile[lockType.remote] = cfg_path + '/' + '.remote.lock';
	if (!lockFile[lockType.fileInfos]) lockFile[lockType.fileInfos] = cfg_path + '/' + '.finfos.lock';
	if (fs.existsSync(lockFile[lockType.remote])) fs.unlink(lockFile[lockType.remote]);
	if (fs.existsSync(lockFile[lockType.fileInfos])) fs.unlink(lockFile[lockType.fileInfos]);
}

function save(cb) {
	waitLock(lockType.fileInfos, function () {
		console.log("Saving config file");
		fs.writeFileSync(file_conf_name, JSON.stringify(finfos, null, 4));
		if (cb) cb();
	});
	var ev = new Event('update_sensors');
	document.dispatchEvent(ev);
	/*
	if (!save.hdle) save.hdle = [];
	var hdle = setInterval(function () {
		if (getLock(lockType.fileInfos)) {
			fs.writeFileSync(fname, JSON.stringify(finfos, null, 4));
			unLock(lockType.fileInfos);
			clearInterval(save.hdle.shift());
		}
	}, 1000);
	save.hdle.push(hdle);
	*/
}

function addFile(fname) {
	finfos.files[fname] = {
		offset: 0,
		nb_items_recv: 0,
		nb_items_sent: 0,
	};
}
function getOrSetFilePath(path) {
	if (!finfos.path && path) finfos.path = path;
	return finfos.path;
}
function updateFilesvalue(fname, vals) {
	if (!finfos.files[fname]) addFile(fname);
	if (vals) {
		if (vals.offset) finfos.files[fname].offset = vals.offset;
		if (vals.nb_items_recv) finfos.files[fname].nb_items_recv = vals.nb_items_recv;
	}
}

function incFilesValues(fname, vals) {
	if (!finfos.files[fname]) addFile(fname);
	if (vals) {
		if (vals.offset) finfos.files[fname].offset += vals.offset;
		if (vals.nb_items_recv) finfos.files[fname].nb_items_recv += vals.nb_items_recv;
		if (vals.nb_items_sent) finfos.files[fname].nb_items_sent += vals.nb_items_sent;
	}
}

function getFiles() {
	return Object.keys(finfos.files);
}

function getValue(fname, key) {
	return finfos.files[fname][key];
}

function getValues(fname, key) {
	var f = fname.split('.')[0].split('_');
	return {
		serial: f[1],
		dau_id: f[3],
		stype: f[4],
		sid:f[5],
		nb_items_recv: getValue(fname, 'nb_items_recv'),
		nb_items_sent: getValue(fname, 'nb_items_sent'),
	};
}

function getSensorStats(cb) {
	if (!cb) return;
	var files = getFiles();
	files.forEach(function (item) {
		cb(getValues(item));
	});
}

function fileLock() {
	return getLock(lockType.remote);
}

function fileUnlock() {
	return unLock(lockType.remote);
}

function fileWaitLock(timeout, cb) {
	waitLock(lockType.remote, cb, timeout);
}

function waitLock(ltype, cb, timeout) {
	if (!waitLock.hdle) {
		waitLock.hdle = [[], []];
	}

	var hdle = setInterval(function () {
		if (getLock(ltype)) {
			if (cb) cb();
			unLock(ltype);
			clearInterval(waitLock.hdle[ltype].shift());
		}
	}, timeout ? timeout : 1000);
	waitLock.hdle[ltype].push(hdle);
}

function getLock(lType) {
	var ret = false;

	try {
		lockFd[lType] = fs.openSync(lockFile[lType], "wx");
		ret = true;
	} catch (err) {
		if (err.code == 'EEXIST')
			lockFd[lType] = null;
		else {
			throw err;
		}
	}
	return ret;
}

function unLock(lType) {
	if (!lockFd[lType]) return;
	fs.closeSync(lockFd[lType]);
	if (fs.existsSync(lockFile[lType])) fs.unlinkSync(lockFile[lType]);
	lockFd[lType] = null;
}

function checkAllSent() {
	var allFiles = getFiles();
	all_sent = 1;
	allFiles.forEach(function (fname) {
		if (getValue(fname, 'nb_items_sent') < getValue(fname, 'nb_items_recv')) {
			all_sent = 0;
			return false;
		}
	});
	return all_sent;
}

function removeFile(fname) {
	fs.unlinkSync(fname);
}

function removeAll() {
	fss.removeSync(cfg_path);
	load();
}
module.exports = {
	load: load,
	save: save,
	getOrSetFilePath: getOrSetFilePath,
	addFile: addFile,
	incFilesValues: incFilesValues,
	getFiles: getFiles,
	getValue: getValue,
	getValues: getValues,
	fileLock: fileLock,
	fileUnlock: fileUnlock,
	fileWaitLock: fileWaitLock,
	getSensorStats: getSensorStats,
	checkAllSent: checkAllSent,
	removeFile: removeFile,
	removeAll: removeAll
};


/***/ }),
/* 2 */
/***/ (function(module, exports) {

module.exports = require("util");

/***/ }),
/* 3 */
/***/ (function(module, exports) {

module.exports = require("mkdirp");

/***/ }),
/* 4 */
/***/ (function(module, exports) {

module.exports = require("path");

/***/ }),
/* 5 */
/***/ (function(module, exports) {

module.exports = require("http");

/***/ }),
/* 6 */
/***/ (function(module, exports) {

module.exports = require("https");

/***/ }),
/* 7 */
/***/ (function(module, exports, __webpack_require__) {


const domReady = __webpack_require__(8);
const dateFormat = __webpack_require__(9);
const util = __webpack_require__(2);

const sensorsToCloud = __webpack_require__(10);
const sensorsFromSPCU = __webpack_require__(13);
const FileInfo = __webpack_require__(1);
const jsonConfig = __webpack_require__(18);

const cfg_filename = './odc.json';
const fs = __webpack_require__(0);


var cfg = JSON.parse(fs.readFileSync(cfg_filename));
const default_page = 'do_config';
const mode = {
    download: 0,
    upload: 1
};

function dpyPage(page, ev) {
    if (dpyPage.job) {
        dpyPage.job();
        dpyPage.job = null;
    }
    dpyPage.job = page.onEndPage.bind(page);
    dpyPage.page = page;
}

function dpyMsg(_msg) {
    var msg = util.format.apply(this, _msg);
    var date_str = dateFormat(new Date(), 'dd/mm/yyyy HH:MM:ss');
    var logUI = this.page_node.querySelector('.log');
    logUI.innerHTML = "<div><div class='log_date'>" + date_str + "</div><div>" + msg + "</div></div>" + logUI.innerHTML;
    //logUI.scrollTop = logUI.scrollHeight;
}

function ui_page(ev_name, ctx) {
    var _self = this;
    this.ev_name = ev_name;
    this.node_menu = document.querySelector('.menu .right .' + this.ev_name + '.sub');
    this.page_node = document.querySelector('#page_' + this.ev_name);
    this.ctx = ctx;
    this.ctx.parent = this;

    this.onStartPage = function (ev) {
        dpyPage(this, ev);
        if (this.ctx.onStartPage) this.ctx.onStartPage(this, cfg, ev);
    };
    this.onEndPage = function () {

        if (this.ctx.onEndPage) this.ctx.onEndPage(this, cfg);
    };

    this.ctx.menu.left.forEach(function (menu_class) {
        document.querySelector('.menu .left a#do_page_' + menu_class).addEventListener('click', _self.onStartPage.bind(_self));
    });

    this.ctx.menu.right.forEach(function (item_menu) {
        _self.node_menu.querySelector('a.' + item_menu.butClass).addEventListener(item_menu.ev ? item_menu.ev : 'click', item_menu.action.bind(_self));
    });
    if (this.ctx.onInitPage) this.ctx.onInitPage(this, cfg);
}

function tabSensor() {
    var sstats_div = document.querySelector('#page_' + this.ev_name + ' .sensor_stats');
    var nb_items_tot_recv = 0;
    var nb_items_tot_sent = 0;
    sstats_div.innerHTML = "<div class='title'><div>Sensor</div><div>Serial</div><div>Received</div><div>Sent</div></div>";
    FileInfo.getSensorStats(function (item) {

        var html = util.format("<div><div>%s</div><div>%s</div><div>%s</div><div>%s</div></div>", "DAU " + item.dau_id + " " + item.stype + " " + item.sid, item.serial, item.nb_items_recv,
            item.nb_items_sent);
        nb_items_tot_recv += item.nb_items_recv;
        nb_items_tot_sent += item.nb_items_sent;
        sstats_div.innerHTML += html;
    });
    sstats_div.innerHTML += "<div class='tot'><div></div><div></div><div>" + nb_items_tot_recv + "</div><div>" + nb_items_tot_sent + "</div></div>";
}

function loadUI() {
    return action = [
        /* 
        new ui_page('config', {
            onStartPage: function (page, cfg, ev) {
                page.page_node.classList.remove('hide');
                page.node_menu.classList.remove('hide');
                jsonConfig.initEditor(document.getElementById('cfg_editor'), cfg, console);
                document.getElementById('do_page_config').classList.add('select');
            },
            onEndPage: function (page, cfg) {
                page.page_node.classList.add('hide');
                page.node_menu.classList.add('hide');
                document.getElementById('do_page_config').classList.remove('select');
                console.log('Config end.');
            },
            menu: {
                left: ['config'],
                right: [{
                    butClass: 'do_reload',
                    action: function () {
                        jsonConfig.initEditor(document.getElementById('cfg_editor'), cfg, console);
                    }
                }, {
                    butClass: 'do_save',
                    action: function () {
                        console.log(this.name);
                        if (!document.querySelector('button.jsoneditor-schema-error')) {
                            cfg = jsonConfig.saveEditorConfig(cfg_filename);
                            alert('Configuration ends with success');
                        } else {
                            alert("Error: Can't save your configuration.\n Please check values");
                        }
                    }
                }],
            },
        }),
        */
        new ui_page('viewer', {
            onStartPage: function (page, cfg, ev) {
                page.page_node.classList.remove('hide');
                page.node_menu.classList.remove('hide');
                page.ctx.started = false;
                page.node_menu.querySelector('.start').classList.remove('hide');
                page.node_menu.querySelector('.stop').classList.add('hide');
                tabSensor.bind(page)();
                page.ctx.evUpdateSensor = tabSensor.bind(page);
                document.addEventListener('update_sensors', page.ctx.evUpdateSensor);
                // when clicked comes from clickev.target.id is the icon, else it is the <a> balise
                var id = (ev.target.id == "") ? ev.target.parentElement.id : ev.target.id;
                if (ev)
                    page.ctx.mode = (id == 'do_page_download') ? mode.download : mode.upload;
                else
                    page.ctx.mode = mode.download;
                if (page.ctx.mode == mode.upload) {
                    document.getElementById('do_page_download').classList.remove('select');
                    document.getElementById('do_page_upload').classList.add('select');
                    document.querySelector('.dl_menu').classList.add('hide');
                    document.querySelector('.ul_menu').classList.remove('hide');
                    page.ctx.evAllSent = page.ctx.onAllDataSent.bind(page);
                    document.addEventListener('sensors_all_sent', page.ctx.evAllSent);
                } else {
                    document.querySelector('.dl_menu').classList.remove('hide');
                    document.querySelector('.ul_menu').classList.add('hide');
                    document.getElementById('do_page_upload').classList.remove('select');
                    document.getElementById('do_page_download').classList.add('select');

                }
            },
            onEndPage: function (page) {
                page.page_node.classList.add('hide');
                page.node_menu.classList.add('hide');
                page.ctx.started = !page.ctx.started;
                if (page.ctx.mode == mode.upload)
                    document.getElementById('do_page_upload').classList.remove('select');
                else
                    document.getElementById('do_page_download').classList.remove('select');
                page.ctx.stopServer(page);
                if (page.ctx.evUpdateSensor) {
                    document.removeEventListener('update_sensors', page.ctx.evUpdateSensor);
                    page.ctx.evUpdateSensor = null;
                }
                if (page.ctx.evAllSent) {
                    document.removeEventListener('sensors_all_sent', page.ctx.evAllSent);
                    page.ctx.evAllSent = null;
                }
            },
            stopServer: function (page) {
                page.node_menu.querySelector('.start').classList.remove('hide');
                page.node_menu.querySelector('.stop').classList.add('hide');

                if (page.ctx.mode == mode.upload) {
                    sensorsToCloud.stopSent();
                } else {
                    sensorsFromSPCU.stopServer();
                }

            },
            onAllDataSent: function () {
                this.ctx.stopServer(this);
                FileInfo.removeAll();
                alert('All datas had been sent to server');
            },
            evAllSent: null,
            evUpdateSensor: null,
            started: false,
            mode: mode.download,
            menu: {
                left: ['download', 'upload'],
                right: [{
                    butClass: 'do_clear',
                    action: function () {
                        this.page_node.querySelector('.log').innerHTML = "";
                    }
                }, {
                    butClass: 'do_toggle_start',
                    action: function () {
                        this.ctx.started = !this.ctx.started;
                        if (this.ctx.started) {
                            if (cfg.path.length == 0 || cfg.spcu.port.length == 0) {
                                alert('Error Path and Connection Port must be set.');
                                if (cfg.path.length == 0) document.getElementById('path').focus();
                                else document.getElementById('port').focus();
                                return;
                            }
                            this.node_menu.querySelector('.start').classList.add('hide');
                            this.node_menu.querySelector('.stop').classList.remove('hide');

                            if (this.ctx.mode == mode.download)
                                sensorsFromSPCU.startServer(cfg, dpyMsg.bind(this), document);
                            else {
                                if (FileInfo.checkAllSent()) {
                                    this.ctx.onAllDataSent.bind(this)();
                                } else
                                    sensorsToCloud.sendToSensorStream(cfg, dpyMsg.bind(this), document, window.console);
                            }
                        } else {
                            this.ctx.stopServer(this);
                        }
                    }
                }],
            },
        })
    ];
}

function initCfg() {
    FileInfo.load(cfg.path, cfg_filename, document);
    jsonConfig.initCfg(cfg);
}

function setInputErr(iinput, err) {
    iinput.classList.add('error');
    alert("Error:" + err.value);
    iinput.focus();
}

function initUICfgValue() {
    document.getElementById('path').value = cfg.path;
    document.getElementById('port').value = cfg.spcu.port;
    document.getElementById('nb_per_sframe').value = cfg.cloud.nb_data_per_frame;
    document.getElementById('period').value = cfg.cloud.frequency;
}
domReady(function () {
    console.log("DOM is ready !!");
    initCfg();
    loadUI();
    [].forEach.call(document.querySelectorAll('input'), function (iinput) {
        iinput.addEventListener('change', function (ev) {
            var err = {};
            var prop_name;
            console.log(ev.target.id);
            switch (ev.target.id) {
                case 'vpath':
                    if (!jsonConfig.updateDlCfg(cfg_filename, 'path', this.value, err)) setInputErr(document.getElementById(path), err);
                    break;
                case 'port':
                    if (!jsonConfig.updateDlCfg(cfg_filename, ev.target.id, this.value, err)) setInputErr(ev.target, err);
                    break;
                case 'nb_per_sframe':
                case 'period':
                    if (!jsonConfig.updateUlCfg(cfg_filename, ev.target.id, this.value, err)) setInputErr(ev.target, err);
                    break;
            }
            if (!err.value) {
                ev.target.classList.remove('error');
            }
        });
    });
    initUICfgValue();
    document.getElementById('vpath').addEventListener('change', function (ev) {
        document.getElementById('path').value = this.value;
    });

    document.getElementById('path_select').addEventListener('click', function (ev) {
        document.getElementById('vpath').click();
    });


    document.querySelector('#do_page_download').click();
});


/***/ }),
/* 8 */
/***/ (function(module, exports) {

module.exports = require("domready");

/***/ }),
/* 9 */
/***/ (function(module, exports) {

module.exports = require("dateformat");

/***/ }),
/* 10 */
/***/ (function(module, exports, __webpack_require__) {

const FileInfo = __webpack_require__(1);
const fs = __webpack_require__(0);
const http = __webpack_require__(5);
const https = __webpack_require__(6);
const Readable = __webpack_require__(12).Readable;
const util = __webpack_require__(2);
const path = __webpack_require__(4);

var sensorStream = null;
var cb_msg = null;
var cfg = null;
var stopServer = false;
var console = null;
var document = null;
var conn = {
    req_stack: [],
};
var sync_time = {
    start: null,
    end: null
};
var wait_delay_hdle = null;
var msg = '';

function infoMsg() {
    arguments[0] = "DataCollector &rArr; Server: " + arguments[0];
    if (cb_msg) cb_msg(arguments);
}

function infoConsole() {
    if (console) console.log.call(arguments);
}

function getFd(fname) {
    if (!getFd.fds) getFd.fds = {};
    if (!getFd.fds[fname]) {
        getFd.fds[fname] = fs.openSync(fname, 'a+');
    }
    return getFd.fds[fname];
}

function removeFd(fname) {
    if (getFd.fds[fname]) {
        fs.closeSync(getFd.fds[fname]);
        getFd.fds[fname] = null;
    }
}

function removeAllFd() {
    if (getFd.fs) {
        FileInfo.getFiles().forEach(function (lfname) {
            var fname = FileInfo.getOrSetFilePath() + '/' + lfname;
            removeFd(fname);
        });
    }
}

function readLineFd(fd, offset) {
    var line = '';
    var c = new Buffer('0');
    var pos = 0;
    var nb_bytes = 0;
    const end_char = '\n'.charCodeAt(0);
    const bend_char = '\r'.charCodeAt(0);
    for (var pos = 0; c[0] != end_char; pos++) {
        var d_nb_bytes = fs.readSync(fd, c, 0, 1, offset++);
        if (!d_nb_bytes) break;
        if (c[0] != end_char && c[0] != bend_char) line += c.toString();
        nb_bytes += d_nb_bytes;
    }

    return {
        size: nb_bytes,
        line: line
    };
}

function prepareHttpHeader(filePath) {

    var http_info = filePath.split('/');
    return {
        'user-agent': http_info[1],
        'x-spcu-action': http_info[2],
        'x-spcu-version': http_info[3],
    };
}

function prepareJSONObject(fname) {
    var ss_info = path.basename(fname).split('.')[0].split('_');
    return {
        action: ss_info[0],
        SN: ss_info[1],
        dau_idx: parseInt(ss_info[3]),
        type: ss_info[4],
        idx: parseInt(ss_info[5]),
    };
}

function prepareMessage() {
    var http_hd = null;
    var nb_ss = 0;
    conn.req_stack = [];
    console.log("send_data starts");
    var tot_bytes = 0;
    var msg = '';

    msg += '{"dau_array": [';
    FileInfo.getFiles().forEach(function (lfname) {
        var fname = FileInfo.getOrSetFilePath() + '/' + lfname;
        var ss_colon = (nb_ss > 0) ? ',' : '';
        var fd = getFd(fname);
        var offset = FileInfo.getValue(lfname, 'offset');
        var nb_bytes = 0;
        var ss = prepareJSONObject(lfname);
        var sname = [ss.dau_idx, ss.type, ss.idx].join(' ');
        //infoMsg('Reading %s datas', sname);
        msg += util.format('%s{"action":"%s","SN":"%s","dau_idx":%i,"type":"%s","idx":%i,"frames":[',
            ss_colon, ss.action, ss.SN, ss.dau_idx, ss.type, ss.idx);
        var nb_sensor_sent = 0;
        for (var i = 0; i < cfg.cloud.nb_data_per_frame; i++) {
            var res = readLineFd(fd, offset + nb_bytes);
            var colon = (i > 0) ? "," : "";
            //infoMsg('readLine returns', res);

            nb_bytes += res.size;
            if (res.size) {
                msg += colon + res.line;
                nb_sensor_sent++;
            } else {
                infoMsg("No more datas to send from %s", sname);
                removeFd(fname);
                //FileInfo.removeFile(fname);
                break;
            }
        }
        if (nb_sensor_sent > 0) {
            console.log('Sending %d', nb_sensor_sent);
            conn.req_stack.push({
                lfname: lfname,
                nb_items_sent: nb_sensor_sent,
                offset: nb_bytes,
                ss: {
                    SN: ss.SN,
                    dau_idx: ss.dau_idx,
                    stype: ss.type,
                    sid: ss.idx
                },
            });
        }
        msg += ']}';
        nb_ss++;

    });
    msg += ']}';
    return msg;
}

function sendData(post_req) {
    try {
        post_req.write(msg);
        post_req.end();

    } catch (err) {
        (e) =>
        infoMsg(err.stack || err);
    }
    return true;
}

function lSetTimeout(cb, delay) {
    if (cb) {
        lSetTimeout.hdle = setTimeout(cb, delay);
        return lSetTimeout.hdle;
    } else {
        if (lSetTimeout.hdle) {
            clearTimeout(lSetTimeout.hdle);
            lSetTimeout.hdle = null;
        }
    }
}

function prepareRemote(http_info) {
    var http_client = cfg.cloud.proto == 'https' ? https : http;
    msg = prepareMessage();
    var http_opts = {
        host: cfg.cloud.hostname,
        port: cfg.cloud.port,
        path: cfg.cloud.rel_path,
        json: true,
        method: 'POST',
        headers: {
            'content-type': 'application/json; charset=UTF-8',
            'user-agent': http_info['user-agent'],
            'x-spcu-action': http_info['x-spcu-action'],
            'x-spcu-version': http_info['x-spcu-version'],
            'Content-Length': msg.length,
            'Expect': '100-continue',
        }
    };
    /*
        if (cfg.cloud.do_chunk) {
            http_opts.headers['Transfer-Encoding'] = 'chunked';
        }
    */
    if (cfg.cloud.proto == 'https') {
        http_opts.pfx = fs.readFileSync(cfg.cloud.pfx);
        http_opts.passphrase = cfg.cloud.pfx_pass;
        http_opts.requestCert = true;
        http_opts.rejectUnauthorized = false;
    }

    return http_client.request(http_opts, function (res) {
        res.setEncoding('utf8');
        res.on('data', () => {
            infoMsg('Data sent');
        });
        res.on('end', () => {
            infoMsg('data sent OK.');
            conn.req_stack.forEach(function (item) {
                infoMsg('DAU_%d_%s_%d sents %d sensor datas', item.ss.dau_idx, item.ss.stype, item.ss.sid, item.nb_items_sent);
                console.log('Updating %s', item.lfname);
                FileInfo.incFilesValues(item.lfname, {
                    nb_items_sent: item.nb_items_sent,
                    offset: item.offset,
                });
            });
            FileInfo.save(function () {
                var delay = (cfg.cloud.frequency * 1000) - (performance.now() - sync_time.start);
                if (delay > 0) {
                    infoMsg("Waiting %dms before sending", parseInt(delay));
                    lSetTimeout(startSend, delay);
                    return;
                } else {
                    startSend();
                }
            });
        });
        res.on('error', (e) => {
            infoMsg('req error', JSON.stringify(e));
            sync_time.end = performance.now();
            lSetTimeout(startSend, 2000);
        });
    });
}

function startSend() {
    if (stopServer) {
        infoMsg('Stop by user !!!!');
        if (startSend.post_req) startSend.post_req.abort();
        return;
    }
    if (FileInfo.checkAllSent()) {
        var ev = new Event('sensors_all_sent');
        document.dispatchEvent(ev);
        infoMsg('All datas had been sent.');
        removeAllFd();
        return;
    }
    sync_time.start = performance.now();
    var http_info = prepareHttpHeader(FileInfo.getOrSetFilePath());
    startSend.post_req = prepareRemote(http_info);
    startSend.post_req.on('error', function (err) {
        infoMsg("Error: %s &rArr; Can't connect to %s://%s/%s:%s", err.code, cfg.cloud.proto, cfg.cloud.hostname, cfg.cloud.path, cfg.cloud.port);
        lSetTimeout(startSend, 2000);
    });
    startSend.post_req.on('connect', function () {
        infoMsg("Connected: %s", JSON.stringify(err));

    });
    sendData(startSend.post_req);
}

function sendToSensorStream(_cfg, _cb_msg, _doc, _console) {
    if (_cb_msg) cb_msg = _cb_msg;
    if (_cfg) cfg = _cfg;
    if (!document) document = _doc;
    if (_console) {
        console = _console;
        console.log('Console initialized !!!');
    }
    stopServer = false;
    startSend();
}

function stopSent() {
    if (stopServer) return;
    lSetTimeout();
    removeAllFd();
    stopServer = true;
    infoMsg('Stop sending datas to cloud.');
}


module.exports = {
    sendToSensorStream: sendToSensorStream,
    stopSent: stopSent
};


/***/ }),
/* 11 */
/***/ (function(module, exports) {

module.exports = require("fs-extra");

/***/ }),
/* 12 */
/***/ (function(module, exports) {

module.exports = require("stream");

/***/ }),
/* 13 */
/***/ (function(module, exports, __webpack_require__) {

const http = __webpack_require__(5);
const https = __webpack_require__(6);
__webpack_require__(14).extend();
const fs = __webpack_require__(0);
const mkdirp = __webpack_require__(3);
const JSONStream = __webpack_require__(15);
const evS = __webpack_require__(16);
const ndjson = __webpack_require__(17);


const FileInfo = __webpack_require__(1);

var server = null;
var cfg = null;
var cb_msg = null;

function json2NdJSON(ss) {
	var lfname = [ss.action, ss.SN, 'DAU', ss.dau_idx, ss.type, ss.idx].join('_') + '.ndjson';
	var fname = FileInfo.getOrSetFilePath() + '/' + lfname;
	var resp = this.resp;
	var sname = ['DAU', ss.dau_idx, ss.type, ss.idx].join(' ');
	if (!fs.existsSync(fname)) FileInfo.addFile(lfname);

	// Pipe the ndjson serialized output to the file-system.
	var toNdJSonStream = ndjson.stringify();

	var out = toNdJSonStream.pipe(fs.createWriteStream(fname, {
		flags: 'a',
		encoding: 'utf8'
	}));
	ss.frames.forEach(function (ss_data) {
		//		infoMsg(chalk.green(JSON.stringify(ss_data)));
		toNdJSonStream.write(ss_data);
	});
	toNdJSonStream.end();
	out.on('finish', function () {
		FileInfo.incFilesValues(lfname, {
			nb_items_recv: ss.frames.length
		});
		FileInfo.save();

		infoMsg('Stored %d items from %s', ss.frames.length, sname);
		resp.writeHead(200, "OK", {
			'Content-Type': 'text/plain'
		});
		resp.end();
	});
}

function processHttpStreamPost(req, resp) {
	const fpath = [cfg.path, req.headers['user-agent'], req.headers['x-spcu-action'], req.headers['x-spcu-version']].join('/');

	mkdirp.sync(fpath);
	FileInfo.getOrSetFilePath(fpath);
	FileInfo.save();

	var ss = {
		action: null,
		SN: null,
		dau_idx: null,
		type: null,
		idx: null
	};

	var jsonStream = JSONStream.parse('dau_array.*');
	req.pipe(jsonStream).pipe(evS.mapSync(json2NdJSON.bind({
		resp: resp
	})));

}

/* Note: Data structure specs.
 * data = dau_array : [{ 
 * 	action: 'insertmeasure',
 * 	SN: '',
 * 	dau_idx:,
 * 	idx:
 * 	type: ('OPTIC' || 'PT' || 'EXTERNAL'),
 * 	frames : [{time:'', raw:, comp:, trigger:, }, ...]
 * }, ...]
 */

function configServer(req, resp) {
	//infoMsg('headers:' + JSON.stringify(req.headers));
	infoMsg("Receiving datas...");

	req.on('connect', (err) => {
		infoMsg('Receiving datas starting ....');
	});
	req.on('error', (err) => {
		infoMsg(err);
		resp.statusCode = 400;
		resp.end();
	});
	req.on('end', (err) => {
		//infoMsg('End of transaction');
	});

	if (req.method == 'POST') {
		processHttpStreamPost(req, resp);
	} else {
		resp.writeHead(404, "NOT FOUND", {
			'Content-Type': 'text/plain'
		});
		//resp.end();
	}

}

function infoMsg() {
	arguments[0] = "EDAS &rArr; DataCollector: " + arguments[0];
	if (cb_msg) cb_msg(arguments);
}

function loadHttpConfig() {
	var opts = null;

	if (cfg.spcu.proto == 'https') {
		opts = {
			key: [fs.readFileSync(cfg.spcu.key, {
				encoding: 'utf-8'
			})],
			cert: [fs.readFileSync(cfg.spcu.cert, {
				encoding: 'utf-8'
			})],
			ca: [fs.readFileSync(cfg.spcu.ca, {
				encoding: 'utf-8'
			})],
			requestCert: true,
			rejectUnauthorized: false,
		};
		server = https.createServer(opts, configServer);
	} else {
		server = http.createServer(configServer);
	}
}

function startServer(_cfg, _cb_msg) {
	cfg = _cfg;
	cb_msg = _cb_msg;
	if (!startServer.first) {
		startServer.first = 1;
		process.env.NODE_TLS_REJECT_UNAUTHORIZED = "0";
	}

	infoMsg("Listening on port %d", cfg.spcu.port);


	loadHttpConfig();

	server.withShutdown();
	server.listen(cfg.spcu.port);
}

function stopServer() {
	if (!server) return;
	server.shutdown(function () {
		infoMsg('Server stopped');
	});
}

function initServer() {


}
//sensorStream.sendToSensorStream(cfg);

module.exports = {
	startServer: startServer,
	stopServer: stopServer
}


/***/ }),
/* 14 */
/***/ (function(module, exports) {

module.exports = require("http-shutdown");

/***/ }),
/* 15 */
/***/ (function(module, exports) {

module.exports = require("JSONStream");

/***/ }),
/* 16 */
/***/ (function(module, exports) {

module.exports = require("event-stream");

/***/ }),
/* 17 */
/***/ (function(module, exports) {

module.exports = require("ndjson");

/***/ }),
/* 18 */
/***/ (function(module, exports, __webpack_require__) {

//const JSONEditor = require('jsoneditor');

const fs = __webpack_require__(0);

var console = null;
var cfg = null;
var editor = null;

function onConfChange() {
    console.log('change:' + JSON.stringify((this)));
}

function onConfEditable() {
    console.log('edit:' + JSON.stringify((this)));
    return true;
}

function onError() {
    console.log('error: ' + JSON.stringify((this)));
}

function initEditor(div, _cfg, _console) {
    console = _console;
    cfg = _cfg;
    global.console = console;
    if (editor) {
        editor.destroy();
        editor = null;
    }
    div.innerHTML = "";
    const schema = {
        title: "ODC Schema",
        type: "object",
        properties: {
            path: {
                type: "string",
                is_dir_path: true,
            },
            cloud: {
                type: "object",
                properties: {
                    proto: {
                        enum: ["http", "https"],
                    },
                    hostname: {
                        type: "string",
                    },
                    port: {
                        type: "integer",
                    },
                    rel_path: {
                        type: "string",
                    },
                    key: {
                        type: "string",
                        is_path: true,
                    },
                    cert: {
                        type: "string",
                        is_path: true,
                    }
                },
                nb_data_per_frame: {
                    type: "integer"
                },
                frequency: {
                    type: "integer",
                    description: "Set upload frequency in seconds."
                },
            },
            spcu: {
                type: "object",
                properties: {
                    proto: {
                        enum: ["http", "https"],
                    },
                    port: {
                        type: "integer"
                    },
                    key: {
                        type: "string",
                        is_path: true,
                    },
                    cert: {
                        type: "string",
                        is_path: true,
                    },
                    ca: {
                        type: "string",
                        is_path: true,
                    }
                }
            }
        },
        required: ["nb_data_per_frame", "frequency", "path"]
    };
    div.innerHTML = ""
    editor = new JSONEditor(div, {
        search: false,
        mode: 'form',
        history: false,
        name: "Data Collector Configuration",
        onError: onError,
        onEditable: onConfEditable,
        onChange: onConfChange,
        schemaRefs: null,
        schema: schema
    }, _cfg);
    editor.expandAll();
}

function saveEditorConfig(fname) {
    cfg = editor.get();
    saveConfig(fname, editor.get());
    return cfg;
}

function saveConfig(fname, datas) {
    fs.writeFileSync(fname, JSON.stringify(datas, null, 4));
}

function updateDlCfg(fname, name, value, err) {
    switch (name) {
        case 'port':
            if (value != parseInt(value, 10)) {
                if (err) err.value = "This value must be and integer."
                return false;
            }
            cfg.spcu.port = parseInt(value, 10);
            break;
        case 'path':
            cfg.path = value; 
            break;
    }
    
    saveConfig(fname, cfg);
    return true;
}

function updateUlCfg(fname, name, value, err) {
    switch (name) {
        case 'nb_per_sframe':
            if (value != parseInt(value, 10) && value > 5000) {
                if (err) err.value = "This value must be between 0 and 5000."
                return false;
            }
            cfg.cloud.nb_data_per_frame = parseInt(value, 10);
            break;
        case 'period':
            if (value != parseInt(value, 10)) {
                if (err) err.value = "This value must be and integer."
                return false;
            }
            cfg.cloud.frequency = parseInt(value, 10);
            break;
    }
    saveConfig(fname, cfg);
    return true;
}

function initCfg(_cfg) {
    cfg = _cfg;
}

module.exports = {
    initCfg: initCfg,
    initEditor: initEditor,
    saveEditorConfig: saveEditorConfig,
    updateDlCfg: updateDlCfg,
    updateUlCfg: updateUlCfg,
};


/***/ })
/******/ ]);
//# sourceMappingURL=bundle.js.map